<template>
    <div class="row justify-content-center">
        <div class="col-lg-5 col-md-7">
            <div class="card bg-secondary shadow border-0">
                <div class="card-body px-lg-5 py-lg-5">
                    <div class="text-center text-muted mb-4">
                        <h2>Register Account</h2>
                        <span class="text-danger" v-if="error">{{error}}</span>
                    </div>
                    <form role="form" @submit="register">

                        <base-input class="input-group-alternative mb-3"
                                    placeholder="Username"
                                    addon-left-icon="ni ni-single-02"
                                    v-model="username">
                        </base-input>
                        <base-input class="input-group-alternative mb-3"
                                    placeholder="First name"
                                    addon-left-icon="ni ni-collection"
                                    v-model="firstname">
                        </base-input>
                        <base-input class="input-group-alternative mb-3"
                                    placeholder="Last name"
                                    addon-left-icon="ni ni-collection"
                                    v-model="lastname">
                        </base-input>

                        <base-input class="input-group-alternative mb-3"
                                    placeholder="Email"
                                    addon-left-icon="ni ni-email-83"
                                    type="email"
                                    v-model="email">
                        </base-input>

                        <base-input class="input-group-alternative"
                                    placeholder="Organization name"
                                    addon-left-icon="ni ni-briefcase-24"
                                    v-model="organization_name">
                        </base-input>
                        <div class="text-center" ref="test">
                            <button class="btn btn-lg btn-primary" type="submit" :disabled="btnDisable">Register Account</button>
                            <p class="text-info" v-if="load">{{load}}</p>
                        </div>
                    </form>
                </div>
            </div>
            <div class="row mt-3">
                <div class="col-12 text-center">
                    <router-link to="/login" class="text-light">
                        <small>Login</small>
                    </router-link>
                </div>
            </div>
        </div>
    </div>
</template>
<script>
  export default {
    name: 'register',
    data() {
      return {
        username :'',
        firstname :'',
        lastname : '',
        email : '',
        organization_name : '',
        error : '',
        btnDisable : false,
        load :''
      }
    },
    methods: {
        register() {
            if(this.username === ''){
                this.error = 'Please enter username'
            }else if(this.firstname === ''){
                this.error = 'Please enter first name'
            }else if(this.lastname === ''){
                this.error = 'Please enter Last name'
            }else if(this.email === ''){
                this.error = 'Please enter E-mail'
            }else if(this.organization_name === ''){
                this.error = 'Please enter Organization name'
            }else{
                this.btnDisable = true
                this.load = 'Loading...'
                this.$http.post('/manage/register',{
                    username: this.username,
                    firstname: this.firstname,
                    lastname: this.lastname,
                    email: this.email,
                    organization_name: this.organization_name
                })
                .then(response => {
                    this.registerSuccess(response)
                }).catch(() => this.registerFailed())
            }
        },
        registerSuccess(req) {
            if(req.message){
                this.registerFailed()
            }else{
                this.$swal({
                    title: "Register Completed!",
                    text: "Username : " + req.data.username +
                    "\n Password : " + req.data.password +
                    "\n\n or check in your email." +
                    "\n \n Do you want to log in?!",
                    icon: "success",
                    buttons: {
                    cancel: "Cancel",
                    confirm: "Yes",
                }
                }).then((confirm) => {
                    if (confirm) {
                        this.$router.push('/login')
                    } else {
                        location.reload()
                    }
                })
            }
        },
        registerFailed() {
            this.error = 'Register failed!!'
        }
        
    },
  }
</script>
<style>
</style>
